#include"function_define.h"
void ansys_tower(int I_pd){
	ofstream ofile;
	ofile.open("./out_file/Tower_dynamic.txt");
	double gama = 0.5, bita = 0.25*pow((0.5 + gama), 2);
	double a0 = 1.0 / (bita*h*h), a1 = gama / (bita*h), a2 = 1.0 / (bita*h);
	double a3 = 1.0 / (bita * 2) - 1, a4 = gama / (bita)-1, a5 = h / 2.0*(gama / bita - 2);
	double a6 = h*(1 - gama), a7 = gama*h;
	MatrixXd Hz;
	if (I_pd == 0) {
		Hz = A3_T.transpose()*load_t;
	}
	else
	{
		Hz = A3_T.transpose()*load_t_pmn;
	}
	int Num = 3;
	VectorXd f_e(Num), df_e(Num), ddf_e(Num), Q(Num), Q_dt(Num);
	for (int i = 0; i < Num; i++){
		f_e(i) = 0; df_e(i) = 0; ddf_e(i) = 0;
	}
	VectorXd f_e_dt(Num), df_e_dt(Num), ddf_e_dt(Num);
	VectorXd F1(Num);//Ч
	MatrixXd K_T_D(Num, Num);
	MatrixXd ft(Num_cal, Num), dft(Num_cal, Num), ddft(Num_cal, Num);
	for (int j = 0; j < Num; j++) Q(j) = Hz(j, 0);
	ddf_e = M_T.inverse()*(Q - K_T*f_e - C_T*df_e);
	for (int j = 0; j < Num; j++) {
		ft(0, j) = f_e(j);
		dft(0, j) = df_e(j);
		ddft(0, j) = ddf_e(j);
	}
	K_T_D = K_T + a0*M_T + a1*C_T;//Чն
	for (int i = 1; i < Num_cal; i++){
		for (int j = 0; j < Num; j++) Q_dt(j) = Hz(j, i);//t+dtʱ̵ĺ
		F1 = Q_dt + M_T*(a0*f_e + a2*df_e + a3*ddf_e) + C_T*(a1*f_e + a4*df_e + a5*ddf_e);//Ч
		f_e_dt = K_T_D.inverse()*F1;
		ddf_e_dt = a0*(f_e_dt - f_e) - a2*df_e - a3*ddf_e;
		df_e_dt = df_e + a6*ddf_e + a7*ddf_e_dt;
		f_e = f_e_dt;
		df_e = df_e_dt;
		ddf_e = ddf_e_dt;
		for (int j = 0; j < Num; j++) {
			ft(i, j) = f_e(j);
			dft(i, j) = df_e(j);
			ddft(i, j) = ddf_e(j);
		}
	}
	ofile << "ǰģ̬ϵ:" << endl << ft << endl;
	if (I_pd == 0){
		f_t.resize(Num_cal, Num);
		df_t.resize(Num_cal, Num);
		ddf_t.resize(Num_cal, Num);
		f_t = ft;
		df_t = dft;
		ddf_t = ddft;
	}
	else
	{
		f_t_pmn.resize(Num_cal, Num);
		df_t_pmn.resize(Num_cal, Num);
		ddf_t_pmn.resize(Num_cal, Num);
		f_t_pmn = ft;
		df_t_pmn = dft;
		ddf_t_pmn = ddft;
	}
	cout << "The tower has been calculated separately!" << endl;
	//ddf_t.setZero();
}
