#include"function_define.h"
void hcl_hub(){
	//-------תϵ-----------
	ofstream ofile;
	ofile.open("./out_file/Post-processing-Roatinghub.txt");
	F_roatingHub.resize(Num_cal, 8);
	for (int i = 0; i < Num_cal; i++){
		F_roatingHub(i, 0) = F_bladed[0](i, 0) + F_bladed[1](i, 0) + F_bladed[2](i, 0);//Fx
		F_roatingHub(i, 1) = F_bladed[0](i, 1) + F_bladed[1](i, 1)*cos(2.0944) - F_bladed[1](i, 2)*sin(2.0944) + F_bladed[2](i, 1)*cos(2 * 2.0944) - F_bladed[2](i, 2)*sin(2 * 2.0944);//Fy
		F_roatingHub(i, 2) = F_bladed[0](i, 2) + F_bladed[1](i, 1)*sin(2.0944) + F_bladed[1](i, 2)*cos(2.0944) + F_bladed[2](i, 1)*sin(2 * 2.0944) + F_bladed[2](i, 2)*cos(2 * 2.0944);//Fz
		F_roatingHub(i, 3) = sqrt(pow(F_roatingHub(i, 1), 2) + pow(F_roatingHub(i, 2), 2));//Fyz

		F_roatingHub(i, 4) = F_bladed[0](i, 4) + F_bladed[1](i, 4) + F_bladed[2](i, 4) - (F_bladed[0](i, 1) + F_bladed[1](i, 1) + F_bladed[2](i, 1))*R_lg;//Mx
		F_roatingHub(i, 5) = F_bladed[0](i, 5) + F_bladed[1](i, 5)*cos(2.0944) - F_bladed[1](i, 6)*sin(2.0944) + F_bladed[2](i, 5)*cos(2 * 2.0944) - F_bladed[2](i, 6)*sin(2 * 2.0944) + (F_bladed[0](i, 0) + F_bladed[1](i, 0)*cos(2.0944) + F_bladed[2](i, 0)*cos(2 * 2.0944))*R_lg;//My
		F_roatingHub(i, 6) = F_bladed[0](i, 6) + F_bladed[1](i, 5)*sin(2.0944) + F_bladed[1](i, 6)*cos(2.0944) + F_bladed[2](i, 5)*sin(2 * 2.0944) + F_bladed[2](i, 6)*cos(2 * 2.0944) + (F_bladed[1](i, 0)*sin(2.0944) + F_bladed[2](i, 0)*sin(2 * 2.0944))*R_lg;;//Mz
		F_roatingHub(i, 7) = sqrt(pow(F_roatingHub(i, 5), 2) + pow(F_roatingHub(i, 6), 2));//Myz
	}

	ofile << " Fx \t Fy  \t Fz \t Fyz \t Mx \t My \t  Mz \t Myz" << endl;
	for (int i = 0; i < Num_cal; i++){
		for (int j = 0; j < 8; j++){
			ofile << F_roatingHub(i, j) << "\t";
		}
		ofile << endl;
	}
	ofile.close();

	//------------̶챼---------
	ofstream ofile3;
	ofile3.open("./out_file/Post-processing-hub-Fixed.txt");
	F_FixedHub.resize(Num_cal, 8);
	for (int i = 0; i < Num_cal; i++){

		F_FixedHub(i, 0) = F_roatingHub(i, 0);//Fx
		F_FixedHub(i, 1) = F_roatingHub(i, 1)*cos(fai_time(i)) - F_roatingHub(i, 2)*sin(fai_time(i));//Fy
		F_FixedHub(i, 2) = F_roatingHub(i, 1)*sin(fai_time(i)) + F_roatingHub(i, 2)*cos(fai_time(i));//Fz
		F_FixedHub(i, 3) = sqrt(pow(F_FixedHub(i, 1), 2) + pow(F_FixedHub(i, 2), 2));//Fyz

		F_FixedHub(i, 4) = F_roatingHub(i, 4);//Mx
		F_FixedHub(i, 5) = F_roatingHub(i, 5)*cos(fai_time(i)) - F_roatingHub(i, 6)*sin(fai_time(i));//My
		F_FixedHub(i, 6) = F_roatingHub(i, 5)*sin(fai_time(i)) + F_roatingHub(i, 6)*cos(fai_time(i));//Mz
		F_FixedHub(i, 7) = sqrt(pow(F_FixedHub(i, 5), 2) + pow(F_FixedHub(i, 6), 2));//Myz

	}
	ofile3 << " Fx \t Fy  \t Fz \t Fyz \t Mx \t My \t  Mz \t Myz" << endl;
	for (int i = 0; i < Num_cal; i++){
		for (int j = 0; j < 8; j++){
			ofile3 << F_FixedHub(i, j) << "\t";
		}
		ofile3 << endl;
	}
	ofile3.close();
	cout << "hcl_hub end!" << endl;
}