#include"function_define.h"
void hcl_tower_base(){
	ofstream ofile;
	ofile.open("./out_file/Post-processing-tower-base.txt");
	F_towerbase.resize(Num_cal, 8);
	MatrixXd mf_T(1, Num_T), mfr_T(1, Num_T);
	mf_T.setZero();
	mfr_T.setZero();
	VectorXd r_T(N_T), m_r_T(N_T);
	for (int i = 0; i < N_T; i++) {
		r_T(i) = pre_T(i, 0) - pre_T(0, 0); //뾶
		m_r_T(i) = pre_T(i, 2);            //ֲܶ
	}
	double R_T = r_T(N_T - 1);
	for (int i = 0; i < Num_T; i++){
		for (int k = 0; k < N_T - 1; k++){
			double kk = (m_r_T(k + 1) - m_r_T(k)) / (r_T(k + 1) - r_T(k));
			double bb = m_r_T(k) - kk*r_T(k);
			mf_T(0, i) = mf_T(0, i) + 1.0 / (pow(R_T, i + 2))*(1.0 / (i + 4)*kk*(pow((r_T(k + 1)), i + 4) - pow((r_T(k)), i + 4)) + 1.0 / (i + 3)*bb*(pow(r_T(k + 1), i + 3) - pow(r_T(k), i + 3)));
			mfr_T(0, i) = mfr_T(0, i) + 1.0 / (pow(R_T, i + 2))*(1.0 / (i + 5)*kk*(pow((r_T(k + 1)), i + 5) - pow((r_T(k)), i + 5)) + 1.0 / (i + 4)*bb*(pow(r_T(k + 1), i + 4) - pow(r_T(k), i + 4)));
		}
	}
	double mass_tower = 0;
	
	//--Էֲ-----
	for (int k = 0; k < N_T - 1; k++){
		double kk = (m_r_T(k + 1) - m_r_T(k)) / (r_T(k + 1) - r_T(k));
		double bb = m_r_T(k) - kk*r_T(k);
		mass_tower = mass_tower + 0.5*kk*(pow((r_T(k + 1)), 2) - pow((r_T(k)), 2)) + bb*(r_T(k + 1) - r_T(k));
	}
	//--Էֲ-----
	
        /*
	//--߷ֲ-----
	for (int k = 0; k < N_T - 1; k++){
		double kk = -(m_r_T(k + 1) - m_r_T(k)) / (r_T(k + 1)*r_T(k + 1) - r_T(k)*r_T(k));
		double bb = m_r_T(k) - kk*r_T(k)*r_T(k);
		mass_tower = mass_tower + 1.0 / 3 * kk*(pow((r_T(k + 1)), 3) - pow((r_T(k)), 3)) + bb*(r_T(k + 1) - r_T(k));
	}
        */
	//--߷ֲ-----
        ofile<<"The mass of tower"<<mass_tower<<endl;


	VectorXd fai_T(Num_T);
	for (int i = 0; i < Num_T; i++){
		fai_T(i) = 1;
	}
	//-----------------
	MatrixXd F_Tower(1, Num_cal), M_Tower(1, Num_cal);
	F_Tower = mf_T*A3_T*ddf_t.transpose() + M_top*fai_T.transpose()*A3_T*ddf_t.transpose();//ƽԼ
	M_Tower = (mfr_T*A3_T*ddf_t.transpose() + R_T*M_top*fai_T.transpose()*A3_T*ddf_t.transpose());//ƽ

	MatrixXd F_Tower_pmn(1, Num_cal), M_Tower_pmn(1, Num_cal);
	F_Tower_pmn = mf_T*A3_T*ddf_t_pmn.transpose() + M_top*fai_T.transpose()*A3_T*ddf_t_pmn.transpose();//ƽڹԼ
	M_Tower_pmn = -(mfr_T*A3_T*ddf_t_pmn.transpose() + R_T*M_top*fai_T.transpose()*A3_T*ddf_t_pmn.transpose());//ƽڹ

	for (int i = 0; i < Num_cal; i++){
		F_towerbase(i, 0) = F_towertop(i, 0) - F_Tower(0, i);//Fx
		F_towerbase(i, 1) = F_towertop(i, 1) - F_Tower_pmn(0, i);//Fy
		F_towerbase(i, 2) = F_towertop(i, 2) - mass_tower*9.8;//Fz
		F_towerbase(i, 3) = sqrt(pow(F_towerbase(i, 0), 2) + pow(F_towerbase(i, 1), 2));//Fxy

		F_towerbase(i, 4) = F_towertop(i, 4) - F_towertop(i, 1)*R_T - M_Tower_pmn(0, i);//Mx
		F_towerbase(i, 5) = F_towertop(i, 5) + F_towertop(i, 0)*R_T - M_Tower(0, i);//My
		F_towerbase(i, 6) = F_towertop(i, 6);//Mz
		F_towerbase(i, 7) = sqrt(pow(F_towerbase(i, 4), 2) + pow(F_towerbase(i, 5), 2));//Mxy
	}

	ofile << " Fx \t Fy  \t Fz \t Fxy \t Mx \t My \t  Mz \t Mxy" << endl;
	for (int i = 0; i < Num_cal; i++){
		for (int j = 0; j < 8; j++){
			ofile << F_towerbase(i, j) << "\t";
		}
		ofile << endl;
	}
	ofile.close();
	ofile << "hcl_tower_base end!" << endl;
}
